
--To obtain the original and the current cost of a cached entry use the query below:
 
select text, usecounts, original_cost, current_cost, disk_ios_count, context_switches_count, pages_allocated_count 
from sys.dm_exec_cached_plans cp cross apply sys.dm_exec_sql_text(plan_handle) st
join sys.dm_os_memory_cache_entries ce 
on cp.memory_object_address = ce. memory_object_address 
go

/*
Adhoc compiled plan entries are inserted into the cache with a cost of zero 
regardless of their original cost. Their cost is re-set to their original cost on first re-use.

The maximum cost of these entries is 4, and therefore they can survive up 
to a maximum of 2 clock rounds under memory pressure 

Prepared compiled plans are inserted with their original cost, and they can survive up to 8 rounds under memory pressure before 
they are evicted from cache making their maximum cost 256.

Entries in the OBJCP cache store are inserted with their original cost
*/