﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EFInclude
{
    class Program
    {
        static void Main(string[] args)
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query1 = from cust in context.Customers
                             join ord in context.Orders
                             on cust.CustomerID equals ord.CustomerID
                             where cust.CustomerID == "ALFKI"
                             select new { cust.ContactName, ord.OrderDate };

                var l1 = query1.ToList();

                var query2 = from cust in context.Customers
                             .Include("Orders")
                             where cust.CustomerID == "ALFKI"
                             select cust;

                var l2 = query2.ToList();

                var query3 = from cust in context.Customers
                             join ord in context.Orders
                             on cust.CustomerID equals ord.CustomerID
                             join det in context.Order_Details
                             on ord.OrderID equals det.OrderID 
                             where cust.CustomerID == "ALFKI"
                             select new { cust.ContactName, ord.OrderDate, det.ProductID };

                var l3 = query3.ToList();

                var query4 = from cust in context.Customers
                            .Include("Orders.Order_Details")
                             where cust.CustomerID == "ALFKI"
                             select cust;

                var l4 = query4.ToList();

                var query5 = from cust in context.Customers
                             join ord in context.Orders
                             on cust.CustomerID equals ord.CustomerID
                             join det in context.Order_Details
                             on ord.OrderID equals det.OrderID
                             join prod in context.Products
                             on det.ProductID equals prod.ProductID
                             where cust.CustomerID == "ALFKI"
                             select new { cust.ContactName, ord.OrderDate, det.Quantity, prod.ProductName };

                var l5 = query5.ToList();

                var query6 = from cust in context.Customers
                            .Include("Orders.Order_Details.Product")
                             where cust.CustomerID == "ALFKI"
                             select cust;

                var l6 = query6.ToList();

                var query7 = from cust in context.Customers
                             join ord in context.Orders
                             on cust.CustomerID equals ord.CustomerID
                             join det in context.Order_Details
                             on ord.OrderID equals det.OrderID
                             join prod in context.Products
                             on det.ProductID equals prod.ProductID
                             join cat in context.Categories
                             on prod.CategoryID equals cat.CategoryID
                             where cust.CustomerID == "ALFKI"
                             select new { cust.ContactName, ord.OrderDate, det.Quantity, prod.ProductName, cat.CategoryName };

                var l7 = query7.ToList();

                var query8 = from cust in context.Customers
                            .Include("Orders.Order_Details.Product.Category")
                             where cust.CustomerID == "ALFKI"
                             select cust;

                var l8 = query8.ToList();

            }
        }
    }
}
